/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor napoveda.c */

#include <string.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

void
napoveda (void)
{
  unsigned int i, line, uvozovky, nadpis, nadpis2, zavorka, odsazeni;
  int radek, ch;
  char *text_napovedy;
  WINDOW *zapisnik;
  char pom[2];

  odsazeni = (COLS - 80) / 2 + 1;

  print_hl (1, "Npovda se pipravuje k pouit, ekejte ...");
  text_napovedy = text_n2 ();
  i = radek = 0;
  do
    {
      if (text_napovedy[i] == '\n')
	radek++;
    }
  while (text_napovedy[i++] != '\0');

  if ((zapisnik = newpad2 ((radek < LINES) ? LINES : radek, COLS)) == NULL)
    {
      print_hl (1, "Nelze spustit napovedu!");
      if (global_get (g_warning) == g_w_ano)
	perror ("newpad2()");
      return;
    }
  wclear2 (zapisnik);

  wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_HLAVNI));

  for (line = 0; line < ((radek < LINES) ? LINES : radek); line++)
    for (i = 0; i < COLS; i++)
      mvwaddch2 (zapisnik, line, i, ' ');

  wmove2 (zapisnik, 0, 1);

  pom[1] = '\0';
  i = 0;
  uvozovky = nadpis = nadpis2 = zavorka = line = 0;

  do
    {

      if (strncmp (text_napovedy + i, "GNU", 3) == 0)
	{
	  wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_GNU) | A_BOLD);
	  wprintw2 (zapisnik, "GNU");
	  i += 3;
	  continue;
	}
      if (strncmp (text_napovedy + i, "GPL", 3) == 0)
	{
	  wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_GNU));
	  wprintw2 (zapisnik, "GPL");
	  i += 3;
	  continue;
	}
	/*---------------*/
      wattroff2 (zapisnik, A_BOLD);
      wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_HLAVNI));

      if (zavorka && !nadpis && !nadpis2)
	wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_ZAVORKY));

      if (nadpis2 && !nadpis)
	wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_NADPIS2) | A_BOLD);
      if (nadpis)
	wattron2 (zapisnik,
		  COLOR_PAIR (COLOR_NAPOVEDA_NADPIS) /*| A_BOLD */ );
      if (uvozovky && !nadpis && !nadpis2)
	wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_UVOZOVKY));
	/*----------------*/
      if (text_napovedy[i] == '\"')
	{
	  uvozovky = !uvozovky;
	  wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_UVOZOVKY));
	}

      if (text_napovedy[i] == '(')
	{
	  zavorka++;
	  if (!nadpis && !nadpis2)
	    wattron2 (zapisnik, COLOR_PAIR (COLOR_NAPOVEDA_ZAVORKY));
	}

      if (i && text_napovedy[i - 1] == ')')
	{
	  if (zavorka)
	    {
	      zavorka--;
	      /*if (!nadpis && !nadpis2 && !zavorka)
	         wattroff2(zapisnik, A_BOLD); */
	    }
	}
	/*----------------*/

      if (text_napovedy[i] == '\n')
	{
	  line++;
	  wmove2 (zapisnik, line, odsazeni);
	  i++;
	  if (text_napovedy[i] != '\0')
	    continue;
	}

      if (text_napovedy[i] == '')
	{
	  nadpis = !nadpis;
	  i++;
	  continue;
	}

      if (text_napovedy[i] == '|')
	{
	  nadpis2 = !nadpis2;
	  i++;
	  continue;
	}
	/*--------------------*/
      pom[0] = text_napovedy[i];
      wprintw2 (zapisnik, pom);
      i++;

    }
  while (text_napovedy[i] != '\0');
/****************************************************************************/
  line = 0;
  pridej_do_priority_p (1, zapisnik, 0 + line, 0, 0, 0,	/* HLPRINTLINES - 1, */
			LINES - 1, COLS - 1, stdscr, LINES - 1, 0);
  do
    {
      odeber_z_priority (zapisnik);
      pridej_do_priority_p (1, zapisnik, 0 + line, 0, 0, 0,
			    /* HLPRINTLINES - 1, */ LINES - 1,
			    COLS - 1, stdscr, LINES - 1, 0);
      tiskni_dle_priority ();

      ch = getch3 ();
      if (ch == KEY_UP && line != 0)
	line--;
      else if ((ch == KEY_DOWN || ch == ' ') && line < radek - LINES)
	line++;
      else if (ch == KEY_PPAGE)
	{
	  if (line >= LINES)
	    line -= LINES;
	  else
	    line = 0;
	}
      else if (ch == KEY_NPAGE)
	{
	  if (line <= radek - LINES * 2)
	    line += LINES;
	  else
	    line = radek - LINES;
	}

    }
  while (ch != KEY_BACKSPACE && ch != 'k' && ch != 'K');

  odeber_z_priority (zapisnik);
  if (delwin2 (zapisnik) == ERR)
    if (global_get (g_warning) == g_w_ano)
      perror ("delwin()");
  obnov_nadpis ();
  tiskni_dle_priority ();
}
